#!/usr/bin/env python
"""
SchoolTool REST API.
"""

import os
from setuptools import setup, find_packages

if os.path.exists("version.txt"):
    version = open("version.txt").read().strip()
else:
    version = open("version.txt.in").read().strip()

def read(*rnames):
    text = open(os.path.join(os.path.dirname(__file__), *rnames)).read()
    return text

setup(
    name="schooltool.rest",
    description="REST API plugin for SchoolTool",
    long_description=(
        read('README.txt')
        + '\n\n' +
        read('CHANGES.txt')
        ),
    version=version,
    url='http://www.schooltool.org',
    license="GPL",
    maintainer="",
    maintainer_email="",
    platforms=["any"],
    classifiers=["Development Status :: 1 - Planning",
    "Environment :: Web Environment",
    "Intended Audience :: End Users/Desktop",
    "License :: OSI Approved :: GNU General Public License (GPL)",
    "Operating System :: OS Independent",
    "Programming Language :: Python",
    "Programming Language :: Python :: 2.6",
    "Programming Language :: Python :: 2.7",
    "Programming Language :: Zope",
    "Topic :: Education"],
    package_dir={'': 'src'},
    packages=find_packages('src'),
    namespace_packages=["schooltool"],
    install_requires=['schooltool>=2.5dev',
                      'celery',
                      'redis',
                      'bottle',
                      'PasteDeploy',
                      'PasteScript',
                      'Pillow',
                      'pytz',
                      'setuptools',
                      'z3c.autoinclude',
                      'ZODB3',
                      'zodbbrowser',
                      'lazr.restful',
                      ],
    extras_require={'test': ['schooltool.devtools>=0.6'],
                    },
    include_package_data=True,
    zip_safe=False,
    entry_points="""
        [z3c.autoinclude.plugin]
        target = schooltool
        [paste.app_factory]
        rest_api = schooltool.rest.paste:rest_api_factory
        """,
    )
