"""
Schooltool REST API core interfaces.
"""
import sys

from lazr.restful.declarations import exported
from lazr.restful.interfaces import IWebServiceClientRequest
from zope.interface import Attribute
from zope.location.interfaces import IRoot
from zope.location.interfaces import ILocation


class ISchoolToolAPI(IRoot):
    pass


class ITopLevelResource(ILocation):
    pass


class IWebServiceClientRequest_V10(IWebServiceClientRequest):
    pass


class ICommonEntry(ILocation):

    context = Attribute('School Tool object')


ST_CONTEXT_IFC = 'schooltool.rest.interface.export_interface.context_interface'
ST_CONTEXT_ATTR = 'schooltool.rest.interface.export_interface.context_attr'

def export_interface(interface, names=(), ommit=(), adapt=None):
    frame = sys._getframe().f_back
    if names:
        names = tuple(filter(lambda n: n in interface, names))
    else:
        names = tuple(interface)
    for name in names:
        if name in ommit:
            continue
        field = frame.f_locals[name] = exported(interface[name])
        if adapt:
            field.setTaggedValue(ST_CONTEXT_IFC, interface)
            field.setTaggedValue(ST_CONTEXT_ATTR, adapt)
